
RegisterExporter("OGRE 3D (*.mesh)", "*.mesh", "ogre.export")
ogre = {}

function quaternion_to_angle_axis(q)
 -- q.m
  return q
end

function quat_to_angle(q)
  --write(fh,"QUAT",q.x,",",q.y,",",q.z,",",q.w,"\n")
  return 2 * acos(q.w) * 3.1415 / 180.0
--  angle = 2 * Math.acos(q1.w);
--double s = Math.sqrt(1-q1.w*q1.w);
--if (Math.abs(s) < 0.001) s=1;
--x = q1.x / s;
--y = q1.y / s;
--z = q1.z / s;
end

function quat_to_x(q)
  local angle = 2 * acos(q.w);
  local s = sqrt(1-(q.w*q.w))
  if s>-0.001 and s<0.001 then s=1 end
  return q.x /s
end

function quat_to_z(q)
  local angle = 2 * acos(q.w)
  local s = sqrt(1-(q.w*q.w))
  if s>-0.001 and s<0.001 then s=1 end
  return q.z /s
end

function quat_to_y(q)
  local angle = 2 * acos(q.w)
  local s = sqrt(1-(q.w*q.w))
  if s>-0.001 and s<0.001 then s=1 end
  return q.y /s
end


function save_boneOGRE(parent, node)
  
  local bone = tobone(node)
  local matrix = bone:GetLocalMatrix():clone()
  local m_inv=matrix:clone()
  m_inv:clear_translation()
  m_inv:invert()
  local q = m_inv:get_quaternion()

  --q:invert()

  local pos = matrix:pos_component()

  --local rotv = quaternion_to_angle_axis(q)

  local boneindex = bone:GetId()-1

  write(fh,"    <bone id='",boneindex,"' name='",bone:GetName(),"'>\n")
  write(fh,"      <position x='",pos.x,"' y='",pos.y,"' z='",pos.z,"' />\n")
  write(fh,"      <rotation angle='",quat_to_angle(q),"'>\n")
  write(fh,"        <axis x='",quat_to_x(q),"' y='",quat_to_y(q),"' z='",quat_to_z(q),"' />\n")
  write(fh,"      </rotation>\n")

  write(fh,"    </bone>\n")

  -- process children
 local lauf = 0
  for lauf = 0, bone:GetChildCount()-1,1
    do
      local node = bone:GetChild(lauf)
      local classname = node:GetClassName()
      --if strfind(classname, "fxMesh") then save_meshOGRE(bone, node) end
      if strfind(classname, "fxBone") then save_boneOGRE(bone, node) end
    end

end


function save_boneHierarchyOGRE(parent, node, parentname)
  
  local bone = tobone(node)
  if strlen(parentname)>0 then
    write(fh,"    <boneparent bone='",bone:GetName(),"' parent='",parentname,"' />\n")
   end
  -- process children
 local lauf = 0
  for lauf = 0, bone:GetChildCount()-1,1
    do
      local node = bone:GetChild(lauf)
      local classname = node:GetClassName()
      --if strfind(classname, "fxMesh") then save_meshOGRE(bone, node) end
      if strfind(classname, "fxBone") then save_boneHierarchyOGRE(bone, node,bone:GetName()) end
    end

end

function getBiggestFrame(node)
  

  local max=0
  local i=0
  local classname = node:GetClassName()
  if strfind(classname, "fxBone") then 
    local bone = tobone(node)
    for i = 0, bone:GetKeyCount()-1,1
      do
	local key = bone:GetKey(i)
        --print("KEY ",key.frame," MAX ",max)
        if key.frame>max then max=key.frame end
      end

  end
  -- process children
  local lauf = 0
  for lauf = 0, node:GetChildCount()-1,1
    do
      local child = node:GetChild(lauf)
      local classname = child:GetClassName()
     
      local curKey=getBiggestFrame(child)
      if curKey>max then max=curKey end 
      
    end
  return max
end

function save_boneAnimationOGRE(node)
  local classname = node:GetClassName()
  if strfind(classname, "fxBone") then 
  
  local bone=tobone(node)
  write(fh,"        <track bone='",bone:GetName(),"'>\n")
  write(fh,"          <keyframes>\n")
  local i=0
  for i = 0, bone:GetKeyCount()-1,1
    do
      local key=bone:GetKey(i)
      local matrix = key.matrix:clone()
      local m_inv=matrix:clone()
      m_inv:clear_translation()
      --m_inv:invert()
      local t=matrix:pos_component()
 
      local q = m_inv:get_quaternion()

      --local rotv = quaternion_to_angle_axis(q)
      
      local angle=quat_to_angle(q)
      local ax=quat_to_x(q)
      local ay=quat_to_y(q)
      local az=quat_to_z(q)
      
      write(fh,"            <keyframe time='",key.frame,"'>\n") --GetTotalFrames()/GetFrameRate()/GetTotalFrames()* 
      write(fh,"              <translate x='",t.x,"' y='",t.y,"' z='",t.z,"' />\n")
      write(fh,"              <rotate angle='",angle,"'>\n")
      write(fh,"                <axis x='",ax,"' y='",ay,"' z='",az,"' />\n")
      write(fh,"              </rotate>\n")
      write(fh,"            </keyframe>\n")
    end
  write(fh,"          </keyframes>\n")
  write(fh,"        </track>\n")
  end
    -- process children
  local lauf = 0
  for lauf = 0, node:GetChildCount()-1,1
    do
      local child = node:GetChild(lauf)
     
      save_boneAnimationOGRE(child)      
    end
  return max
end


-- save one fxMesh
------------------------------------------------------------------------------------------
function save_meshOGRE(parent, node)
mesh = tomesh(node)
local m=mesh:GetMaterial()
m="Antargis/ManDagger"
write(fh, "    <submesh material='Material0' usesharedvertices='false' ")
write(fh,"use32bitindexes='false' operationtype='triangle_list'>\n")


-- save the faces
write(fh,"      <faces count='",mesh:GetFaceCount(),"'>\n")
for i = 0, mesh:GetFaceCount()-1,1
	do
	f1, f2, f3 = mesh:GetFace(i)

write(fh,"        <face v1='",f1,"' v2='",f2,"' v3='",f3,"' />\n")

	--write(fh, "mesh:AddFace(v", f1, ",v", f2, ",v", f3, ")\n")

	end
write(fh,"      </faces>\n")


mesh:GetFaceCount()
write(fh, "      <geometry vertexcount='",mesh:GetVertexCount(),"'>\n")
write(fh, "        <vertexbuffer positions='true' normals='true'>\n")
for i = 0, mesh:GetVertexCount()-1,1
	do
	v = mesh:GetVertex(i)
write(fh, "          <vertex>\n")
write(fh, "            <position x='",v.position.x,"' y='",v.position.y,"' z='",v.position.z,"' />\n")
write(fh, "            <normal x='",v.normal.x,"' y='",v.normal.y,"' z='",v.normal.z,"' />\n")
write(fh, "          </vertex>\n")

	end



write(fh, "        </vertexbuffer>\n")
write(fh, "        <vertexbuffer texture_coord_dimensions_0='2' texture_coords='1'>\n")
for i = 0, mesh:GetVertexCount()-1,1
	do
	v = mesh:GetVertex(i)
write(fh, "          <vertex>\n")
write(fh, "            <texcoord u='",v.texcoords.x,"' v='",(1-v.texcoords.y),"' />\n")

write(fh, "          </vertex>\n")
	end
write(fh, "        </vertexbuffer>\n")


--write(fh, "v:delete()\n")
write(fh, "      </geometry>\n")


--            <boneassignments>
--                <vertexboneassignment vertexindex="0" boneindex="12" weight="1" />
--                <vertexboneassignment vertexindex="1" boneindex="12" weight="1" />

write(fh, "      <boneassignments>\n")
for i = 0, mesh:GetVertexCount()-1,1
	do
	v = mesh:GetVertex(i)
if v.bone[1]>=0 then
  write(fh, "          <vertexboneassignment vertexindex='",i,"' boneindex='",(v.bone[1]-1),"' weight='",v.weight[1],"' />\n")
end
if v.bone[2]>=0 then
  write(fh, "          <vertexboneassignment vertexindex='",i,"' boneindex='",(v.bone[2]-1),"' weight='",v.weight[2],"' />\n")
end
if v.bone[3]>=0 then
  write(fh, "          <vertexboneassignment vertexindex='",i,"' boneindex='",(v.bone[3]-1),"' weight='",v.weight[3],"' />\n")
end
if v.bone[4]>=0 then
  write(fh, "          <vertexboneassignment vertexindex='",i,"' boneindex='",(v.bone[4]-1),"' weight='",v.weight[4],"' />\n")
end
--	write(fh, "v:set(")
 --       write(fh, "false,")
  --      write(fh, v.position.x, ",")
--        write(fh, v.position.y, ",")
--	write(fh, v.position.z, ",")
--	write(fh, v.normal.x,   ",")
--  	write(fh, v.normal.y,   ",")
--	write(fh, v.normal.z,   ",")
--	write(fh, v.texcoords.x,",")
--	write(fh, v.texcoords.y,",")
--	write(fh, v.bone[1],    ",")
--	write(fh, v.bone[2],    ",")
--	write(fh, v.bone[3],    ",")
--	write(fh, v.bone[4],    ",")
--	write(fh, v.weight[1],  ",")
--	write(fh, v.weight[2],  ",")
  --	write(fh, v.weight[3],  ",")
	--write(fh, v.weight[4], ")\n")
end
write(fh, "      </boneassignments>\n")



--finally link the mesh into the scene
--write(fh, "rootnode:AttachChild(mesh)\n")

write(fh, "    </submesh>\n")
end

-- save the materials
---------------------------------------------------------------------------------------------------
function save_materialsOGRE()
local mat_count = GetTextureCount()
for i = 0,mat_count-1,1
	do
	mat = GetTexture(i)

        write(fh, "material Material0\n")
        write(fh, "{\n")
        write(fh, "      technique\n")
        write(fh, "      {\n")
        write(fh, "            pass\n")
        write(fh, "            {\n")
        write(fh, "                  ambient 0.2 0.2 0.2 1\n")
        write(fh, "                  diffuse 0.8 0.8 0.8 1\n")
        write(fh, "\n")
        write(fh, "                  texture_unit\n")
        write(fh, "                  {\n")
        write(fh, "                        texture_alias 0\n")
        write(fh, "                        texture ", mat:GetFileName()," \n")
        write(fh, "                  }\n")
        write(fh, "            }\n")
        write(fh, "      }\n")
        write(fh, "}\n")

        end

end


-- saves the workspace
---------------------------------------------------------------------------------------------------
function save_viewportsOGRE()
   local i
   write(fh, "CloseAllViewports()\n")
   for i = 0,GetViewportCount()-1,1
      do
      local vp = GetViewport(i)
      write(fh, "vp = CreateViewport()\n")
      local left, top, width, height = vp:GetRect()
      local s = format("%.8f, %.8f, %.8f, %.8f", left, top, width, height)
      write(fh, "vp:SetRect(",s,")\n")

      local data = vp:GetData1()
      write(fh, "vp:SetData1(", data.x, ", ", data.y, ", ", data.z,")\n")
      local data = vp:GetData2()
      write(fh, "vp:SetData2(", data.x, ", ", data.y, ", ", data.z,")\n")
      local data = vp:GetData3()
      write(fh, "vp:SetData3(", data.x, ", ", data.y, ", ", data.z,")\n")
      local data = vp:GetData4()
      write(fh, "vp:SetData4(", data.x, ", ", data.y, ", ", data.z,")\n")
      local data = vp:GetData5()
      write(fh, "vp:SetData5(", data.x, ", ", data.y, ", ", data.z,")\n")

      local proj = vp:GetProjection()
      write(fh, "vp:SetProjection(",proj,")\n")

      local drawmode = vp:GetDrawMode()
      write(fh, "vp:SetDrawMode(",drawmode,")\n")   

      local drawbf = vp:GetDrawBF()
      write(fh, "vp:SetDrawBF(",drawbf,")\n")

      local drawgrid = vp:GetDrawGrid()
      write(fh, "vp:SetDrawGrid(",drawgrid,")\n")

      write(fh, "RedrawViewports()\n")
      end
end


-- main function
---------------------------------------------------------------------------------------------------
--fh = openfile("Plugins/OGREtemp/ogre.temp", "wt")

function ogre.export(filename)

--write(fh, filename);
--closefile(fh)

fh = openfile(filename..".material", "wt")

save_materialsOGRE()

closefile(fh)

fh = openfile(filename..".mesh.xml", "wt")
if not fh then error("Could not create file!") end

write(fh, "<mesh>\n");
write(fh, "  <submeshes>\n");

--write(fh, "scene = GetScene()\n")
--write(fh, "rootnode = scene:GetRootNode()\n")
--write(fh, "SetTotalFrames(",GetTotalFrames(),")\n")
--write(fh, "SetFrame(", GetFrame(), ")\n")
--write(fh, "SetFrameRate(",GetFrameRate(),")\n")

-- save_viewports()

scene = GetScene()
root = scene:GetRootNode()

for i = 0, root:GetChildCount()-1,1
	do
	node = root:GetChild(i)
	classname = node:GetClassName()
	if strfind(classname, "fxMesh") then save_meshOGRE(root, node) end
-- omit bones for now
	--if strfind(classname, "fxBone") then save_boneOGRE(root, node) end 
	end
write(fh, "  </submeshes>\n");

write(fh, "  <skeletonlink name='",filename,".skeleton' />\n")

write(fh, "</mesh>\n");

closefile(fh)

fh = openfile(filename..".skeleton.xml", "wt")
write(fh, "<skeleton>\n")
write(fh, "  <bones>\n")
for i = 0, root:GetChildCount()-1,1
  do
    node = root:GetChild(i)
    classname = node:GetClassName()
    if strfind(classname, "fxBone") then save_boneOGRE(root, node) end 
  end
write(fh, "  </bones>\n")
write(fh, "  <bonehierarchy>\n")
for i = 0, root:GetChildCount()-1,1
  do
    node = root:GetChild(i)
    classname = node:GetClassName()
    if strfind(classname, "fxBone") then save_boneHierarchyOGRE(root, node,"") end 
  end


write(fh, "  </bonehierarchy>\n")
write(fh, "  <animations>\n")
write(fh, "    <animation name='Animation' length='",getBiggestFrame(root)/GetFrameRate(),"'>\n")
write(fh, "      <tracks>\n")
for i = 0, root:GetChildCount()-1,1
  do
    print("getI",i)
    node = root:GetChild(i)
    print("okgetI",i)
    classname = node:GetClassName()
    if strfind(classname, "fxBone") then save_boneAnimationOGRE(node) end 
  end

write(fh, "      </tracks>\n")
write(fh, "    </animation>\n")
write(fh, "  </animations>\n")
write(fh, "</skeleton>\n")
closefile(fh)

end